/**********************************************************************************
 *   :
 *     :ֻͨͶſLED
 * ʵƽ̨:STC12XX
 * 汾  :
 *     :ͨģ鿪ƽ̨Ŷ 
 *     :http://nirenelec.blog.163.com
 * Ա    :http://shop105683814.taobao.com
**********************************************************************************/

#include "string.h"
#include "delay.h"
#include "uart.h"


#define Buf1_Max 60 					  //1泤
#define Buf2_Max 200 					  //2泤
/*************	س	**************/
//sbit RUNING_LED = P2^1;					//ָʾ
//sbit LED  			= P3^3;					//ָʾ
sbit ENA=P1^4;
sbit IN1=P1^5;
sbit IN2=P1^6;

/*************  ر	**************/
xdata u8 Uart1_Buf[Buf1_Max];
xdata u8 Uart2_Buf[Buf2_Max];

u8 Times=0,First_Int = 0,shijian=0;
//u8 Time_count=0;
bdata u8 Flag;//ʱ־λ
sbit Timer0_start =Flag^0;	//ʱ0ʱ
sbit Uart2_Start  =Flag^1;	//2ʼ
sbit Uart2_End		=Flag^2;	//2ݽ


/*************	غ	**************/
void GPIO_config(void);
void Timer0Init(void);
void CLR_Buf2(void);
u8 Find(u8 *a);
void Second_AT_Command(u8 *b,u8 wait_time);
void Set_Text_Mode(void);
void Check_New_Message(void);
void Wait_CREG(void);

/*************  ⲿͱ*****************/




/*******************************************************************************
*  : main 
*    : 
*    : 
*    : 
*    : 
* ע   : 2GPRSģͨţ1ڴڵԣԱسʱ
					 ͵ģ
*******************************************************************************/
void main(void)
{
	GPIO_config();
	Uart1Init();
	Uart2Init();
	Timer0Init();
	EA=1;	//ж
	UART1_SendString("GPRSģŲԳ\r\n");
	UART1_SendString("GPRSģע\r\n");
	Wait_CREG();
	UART1_SendString("GPRSģעɹ\r\n");
	UART1_SendString("GPRSģģʽ\r\n");
	Set_Text_Mode();
	UART1_SendString("óɹģʽTEXT\r\n");
	
	UART1_SendString("ʼ\r\n");
	while(1)
	{
		Check_New_Message();
	}
	
}

/*******************************************************************************
*  : Uart1 
*    : 1жϷں
*    : 
*    : 
*    : 
* ע   : 
*******************************************************************************/
void Uart1() interrupt 4
{
    if (RI)
    {
        RI = 0;                 //RIλ
    }
    if (TI)
    {
        TI = 0;                 //TIλ
    }
}

/*******************************************************************************
*  : Uart2
*    : 2жϷں
*    : 
*    : 
*    : 
* ע   : 
*******************************************************************************/
void Uart2() interrupt 8
{
		IE2  &= ~0x01;   //رմ2ж
    if (S2CON & S2RI)
    {
      S2CON &= ~S2RI;         //S2RIλ
			Uart2_Buf[First_Int] = S2BUF;  	  //յַ浽
			First_Int++;                			//ָƶ
			if(First_Int > Buf2_Max)       		//,ָָ򻺴׵ַ
			{
				First_Int = 0;
			}
    }
    if (S2CON & S2TI)
    {
      S2CON &= ~S2TI;         //S2TIλ
    }
		IE2  |= 0x01;   //ʹܴ2ж
}
/*******************************************************************************
*  : Timer0_ISR
*    : ʱ0жϷں,20msжһ
*    : 
*    : 
*    : 
* ע   : 
*******************************************************************************/
void Timer0_ISR() interrupt 1
{
	static u8 Time_count=0; 
	TR0=0;//ضʱ
	Time_count++;
	if(Time_count>=50)
	{
		Time_count = 0;
		//RUNING_LED =~RUNING_LED;
	}
	if(Timer0_start)
	Times++;
	if(Times > (50*shijian))
	{
		Timer0_start = 0;
		Times = 0;
	}
	TR0=1;//ʱ
}
/*******************************************************************************
*  : GPIO_config
*    : IOú
*    : 
*    : 
*    : 
* ע   : 
*******************************************************************************/
void	GPIO_config(void)
{
		P3M1 &= 0XC3;  //P32~P35Ϊ
		P3M0 |=	~0XC3;
		//LED=0;
		ENA=0;
	IN1=1;
	IN2=1;
		//RUNING_LED=0;
}
void Timer0Init(void)		//20@22.1184MHz
{
	AUXR &= 0x7F;	//12Tģʽ
	TMOD &= 0xF0;	//öʱģʽ 16λ
	TL0 = 0x00;		//趨ʱֵ
	TH0 = 0x70;		//趨ʱֵ
	TF0 = 0;			//TF0־
	TR0 = 1;			//ʱ0ʼʱ
	ET0 = 1;    	//ʹܶʱ0ж
}
/*******************************************************************************
*  : CLR_Buf2
*    : 2
*    : 
*    : 
*    : 
* ע   : 
*******************************************************************************/
void CLR_Buf2(void)
{
	u16 k;
	for(k=0;k<Buf2_Max;k++)      //
	{
		Uart2_Buf[k] = 0x00;
	}
    First_Int = 0;              //ַʼ洢λ
}

/*******************************************************************************
*  : Find
*    : жϻǷַָ
*    : 
*    : 
*    : unsigned char:1 ҵַָ0 δҵַָ 
* ע   : 
*******************************************************************************/

u8 Find(u8 *a)
{ 
  if(strstr(Uart2_Buf,a)!=NULL)
	    return 1;
	else
			return 0;
}

/*******************************************************************************
*  : Second_AT_Command
*    : ATָ
*    : ݵָ롢͵ȴʱ(λS)
*    : 
*    : 
* ע   : 
*******************************************************************************/

void Second_AT_Command(u8 *b,u8 wait_time)         
{
	u8 i;
	u8 *c;
	c = b;										//ַַc
	CLR_Buf2(); 
  i = 0;
	while(i == 0)                    
	{
		if(!Find("OK")) 
		{
			if(Timer0_start == 0)
			{
				b = c;							//ַַb
				for (b; *b!='\0';b++)
				{
					UART2_SendData(*b);
				}
				UART2_SendLR();	
				Times = 0;
				shijian = wait_time;
				Timer0_start = 1;
		   }
    }
 	  else
		{
			i = 1;
			Timer0_start = 0;
		}
	}
	CLR_Buf2(); 
}

/*******************************************************************************
*  : Set_Text_Mode
*    : öΪTEXTıģʽ
*    : 
*    : 
*    : 
* ע   : 
*******************************************************************************/
void Set_Text_Mode(void)
{
	Second_AT_Command("ATE0",3);										//ȡ	
	Second_AT_Command("AT+CNMI=3,2,0,0,0",3);							//¶ֱ
	Second_AT_Command("AT+CMGF=1",3);								//TEXTģʽ	
	Second_AT_Command("AT+CPMS=\"SM\",\"SM\",\"SM\"",3);		//вSIMн	
}

/*******************************************************************************
*  : Check_Message_rec
*    : ǷϢִϢָ
*    : 
*    : 
*    : 
* ע   : 
*******************************************************************************/

void Check_New_Message(void)
{
	u8 temp=0;
	if(strstr(Uart2_Buf,"+CMT")!=NULL)   		//ַк"+CMT"ͱʾµĶ
	{
		delay_ms(50);//ȴȫ
		UART1_SendString("յ¶:\r\n");
		UART1_SendString(Uart2_Buf);			//ģ鷵صϢԭ
		if(strstr(Uart2_Buf,"onled")!=NULL)
		{
			IN1 = 0;
			IN2=1;
		}
		if(strstr(Uart2_Buf,"offled")!=NULL)
		{
			IN2 = 0;
			IN1=1;
		}
		CLR_Buf2();
		//Second_AT_Command("AT+CMGD=1,1",3);//ɾ
	}
}

/*******************************************************************************
*  : Wait_CREG
*    : ȴģעɹ
*    : 
*    : 
*    : 
* ע   : 
*******************************************************************************/
void Wait_CREG(void)
{
	u8 i;
	u8 k;
	i = 0;
	CLR_Buf2();
  while(i == 0)        			
	{
		CLR_Buf2();        
		UART2_SendString("AT+CREG?");
		UART2_SendLR();
		delay_ms(5000);  						
	    for(k=0;k<Buf2_Max;k++)      			
    	{
			if(Uart2_Buf[k] == ':')
			{
				if((Uart2_Buf[k+4] == '1')||(Uart2_Buf[k+4] == '5'))
				{
					i = 1;
					UART1_SendLR();
				  break;
				}
			}
		}
		UART1_SendString("ע.....");
	}
}
